import{S as Yr,i as Ur,s as Jr,e as l,k as c,w as _,t as s,M as Kr,c as a,d as t,m as d,a as n,x as w,h as r,b as p,N as Ve,G as o,g as h,y,L as Qr,q as b,o as E,B as A,v as Zr}from"../../chunks/vendor-hf-doc-builder.js";import{I as ne}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as Ll}from"../../chunks/CodeBlock-hf-doc-builder.js";function Vr(rs){let I,ro,P,O,yt,se,Tl,bt,Rl,io,L,re,Sl,ql,Et,Cl,Dl,ho,Xe,Nl,po,f,ie,Ml,he,Ol,Wl,zl,m,Bl,pe,Hl,Fl,ce,Yl,Ul,de,Jl,Kl,fe,Ql,Zl,At,Vl,Xl,et,ea,kt,ta,oa,ue,la,Gt,aa,na,sa,me,ra,$t,ia,ha,co,g,pa,ge,ca,da,ve,fa,ua,_e,ma,ga,fo,we,va,xt,_a,uo,T,W,jt,ye,wa,It,ya,mo,z,ba,Pt,Ea,Aa,go,B,ka,Lt,Ga,$a,vo,H,xa,Tt,ja,Ia,_o,be,is,wo,R,F,Rt,Ee,Pa,St,La,yo,k,Ta,Ae,Ra,Sa,qt,qa,Ca,bo,Y,Da,Ct,Na,Ma,Eo,u,Oa,ke,Wa,za,Ge,Ba,Ha,$e,Fa,Ya,xe,Ua,Ja,Ao,U,Ka,Dt,Qa,Za,ko,tt,Va,Go,G,Nt,je,Xa,en,Mt,Ie,tn,on,Ot,Pe,ln,$o,S,J,Wt,Le,an,zt,nn,xo,ot,sn,jo,K,Bt,Te,rn,hn,Ht,Re,pn,Io,$,cn,Ft,dn,fn,Yt,un,mn,Po,lt,gn,Lo,q,Q,Ut,Se,vn,Jt,_n,To,at,wn,Ro,nt,yn,So,qe,hs,qo,Z,bn,Ce,En,An,Co,De,ps,Do,st,kn,No,Ne,cs,Mo,C,V,Kt,Me,Gn,Qt,$n,Oo,rt,xn,Wo,Oe,ds,zo,x,jn,Zt,In,Pn,Vt,Ln,Tn,Bo,We,fs,Ho,it,Rn,Fo,ze,Yo,ht,Sn,Uo,X,qn,Xt,Cn,Dn,Jo,Be,Ko,pt,Nn,Qo,He,Zo,ct,Mn,Vo,ee,On,eo,Wn,zn,Xo,Fe,el,dt,Bn,tl,Ye,Hn,to,Fn,ol,ft,Yn,ll,Ue,us,al,ut,Un,nl,D,te,oo,Je,Jn,lo,Kn,sl,oe,Qn,Ke,Zn,Vn,rl,N,le,ao,Qe,Xn,no,es,il,Ze,ts,mt,os,hl;return se=new ne({}),ye=new ne({}),Ee=new ne({}),Le=new ne({}),Se=new ne({}),Me=new ne({}),ze=new Ll({props:{code:`#-- Methods that need implementing using the "extend script" option in Godot --#
func get_obs() -> Dictionary:
	assert(false, "the get_obs method is not implemented when extending from ai_controller")
	return {"obs":[]}

func get_reward() -> float:
	assert(false, "the get_reward method is not implemented when extending from ai_controller")
	return 0.0

func get_action_space() -> Dictionary:
	assert(false, "the get get_action_space method is not implemented when extending from ai_controller")
	return {
		"example_actions_continous" : {
			"size": 2,
			"action_type": "continuous"
		},
		"example_actions_discrete" : {
			"size": 2,
			"action_type": "discrete"
		},
		}

func set_action(action) -> void:
	assert(false, "the get set_action method is not implemented when extending from ai_controller")
# -----------------------------------------------------------------------------#`,highlighted:`<span class="hljs-comment">#-- Methods that need implementing using the &quot;extend script&quot; option in Godot --#</span>
func get_obs() -&gt; Dictionary:
	<span class="hljs-keyword">assert</span>(false, <span class="hljs-string">&quot;the get_obs method is not implemented when extending from ai_controller&quot;</span>)
	<span class="hljs-keyword">return</span> {<span class="hljs-string">&quot;obs&quot;</span>:[]}

func get_reward() -&gt; <span class="hljs-built_in">float</span>:
	<span class="hljs-keyword">assert</span>(false, <span class="hljs-string">&quot;the get_reward method is not implemented when extending from ai_controller&quot;</span>)
	<span class="hljs-keyword">return</span> <span class="hljs-number">0.0</span>

func get_action_space() -&gt; Dictionary:
	<span class="hljs-keyword">assert</span>(false, <span class="hljs-string">&quot;the get get_action_space method is not implemented when extending from ai_controller&quot;</span>)
	<span class="hljs-keyword">return</span> {
		<span class="hljs-string">&quot;example_actions_continous&quot;</span> : {
			<span class="hljs-string">&quot;size&quot;</span>: <span class="hljs-number">2</span>,
			<span class="hljs-string">&quot;action_type&quot;</span>: <span class="hljs-string">&quot;continuous&quot;</span>
		},
		<span class="hljs-string">&quot;example_actions_discrete&quot;</span> : {
			<span class="hljs-string">&quot;size&quot;</span>: <span class="hljs-number">2</span>,
			<span class="hljs-string">&quot;action_type&quot;</span>: <span class="hljs-string">&quot;discrete&quot;</span>
		},
		}

func set_action(action) -&gt; void:
	<span class="hljs-keyword">assert</span>(false, <span class="hljs-string">&quot;the get set_action method is not implemented when extending from ai_controller&quot;</span>)
<span class="hljs-comment"># -----------------------------------------------------------------------------#</span>`}}),Be=new Ll({props:{code:`extends AIController3D

# Called when the node enters the scene tree for the first time.
func _ready():
	pass # Replace with function body.

# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	pass`,highlighted:`extends AIController3D

<span class="hljs-comment"># Called when the node enters the scene tree for the first time.</span>
func _ready():
	<span class="hljs-keyword">pass</span> <span class="hljs-comment"># Replace with function body.</span>

<span class="hljs-comment"># Called every frame. &#x27;delta&#x27; is the elapsed time since the previous frame.</span>
func _process(delta):
	<span class="hljs-keyword">pass</span>`}}),He=new Ll({props:{code:`extends AIController3D

# Stores the action sampled for the agent's policy, running in python
var move_action : float = 0.0

func get_obs() -> Dictionary:
	# get the balls position and velocity in the paddle's frame of reference
	var ball_pos = to_local(_player.ball.global_position)
	var ball_vel = to_local(_player.ball.linear_velocity)
	var obs = [ball_pos.x, ball_pos.z, ball_vel.x/10.0, ball_vel.z/10.0]

	return {"obs":obs}

func get_reward() -> float:
	return reward

func get_action_space() -> Dictionary:
	return {
		"move_action" : {
			"size": 1,
			"action_type": "continuous"
		},
		}

func set_action(action) -> void:
	move_action = clamp(action["move_action"][0], -1.0, 1.0)`,highlighted:`extends AIController3D

<span class="hljs-comment"># Stores the action sampled for the agent&#x27;s policy, running in python</span>
var move_action : <span class="hljs-built_in">float</span> = <span class="hljs-number">0.0</span>

func get_obs() -&gt; Dictionary:
	<span class="hljs-comment"># get the balls position and velocity in the paddle&#x27;s frame of reference</span>
	var ball_pos = to_local(_player.ball.global_position)
	var ball_vel = to_local(_player.ball.linear_velocity)
	var obs = [ball_pos.x, ball_pos.z, ball_vel.x/<span class="hljs-number">10.0</span>, ball_vel.z/<span class="hljs-number">10.0</span>]

	<span class="hljs-keyword">return</span> {<span class="hljs-string">&quot;obs&quot;</span>:obs}

func get_reward() -&gt; <span class="hljs-built_in">float</span>:
	<span class="hljs-keyword">return</span> reward

func get_action_space() -&gt; Dictionary:
	<span class="hljs-keyword">return</span> {
		<span class="hljs-string">&quot;move_action&quot;</span> : {
			<span class="hljs-string">&quot;size&quot;</span>: <span class="hljs-number">1</span>,
			<span class="hljs-string">&quot;action_type&quot;</span>: <span class="hljs-string">&quot;continuous&quot;</span>
		},
		}

func set_action(action) -&gt; void:
	move_action = clamp(action[<span class="hljs-string">&quot;move_action&quot;</span>][<span class="hljs-number">0</span>], -<span class="hljs-number">1.0</span>, <span class="hljs-number">1.0</span>)`}}),Fe=new Ll({props:{code:`extends Node3D

@export var rotation_speed = 3.0
@onready var ball = get_node("../Ball")
@onready var ai_controller = $AIController3D

func _ready():
	ai_controller.init(self)

func game_over():
	ai_controller.done = true
	ai_controller.needs_reset = true

func _physics_process(delta):
	if ai_controller.needs_reset:
		ai_controller.reset()
		ball.reset()
		return

	var movement : float
	if ai_controller.heuristic == "human":
		movement = Input.get_axis("rotate_anticlockwise", "rotate_clockwise")
	else:
		movement = ai_controller.move_action
	rotate_y(movement*delta*rotation_speed)

func _on_area_3d_body_entered(body):
	ai_controller.reward += 1.0`,highlighted:`extends Node3D

<span class="hljs-meta">@export var rotation_speed = <span class="hljs-number">3.0</span></span>
<span class="hljs-meta">@onready var ball = get_node(<span class="hljs-params"><span class="hljs-string">&quot;../Ball&quot;</span></span>)</span>
<span class="hljs-meta">@onready var ai_controller = $AIController3D</span>

func _ready():
	ai_controller.init(self)

func game_over():
	ai_controller.done = true
	ai_controller.needs_reset = true

func _physics_process(delta):
	<span class="hljs-keyword">if</span> ai_controller.needs_reset:
		ai_controller.reset()
		ball.reset()
		<span class="hljs-keyword">return</span>

	var movement : <span class="hljs-built_in">float</span>
	<span class="hljs-keyword">if</span> ai_controller.heuristic == <span class="hljs-string">&quot;human&quot;</span>:
		movement = Input.get_axis(<span class="hljs-string">&quot;rotate_anticlockwise&quot;</span>, <span class="hljs-string">&quot;rotate_clockwise&quot;</span>)
	<span class="hljs-keyword">else</span>:
		movement = ai_controller.move_action
	rotate_y(movement*delta*rotation_speed)

func _on_area_3d_body_entered(body):
	ai_controller.reward += <span class="hljs-number">1.0</span>`}}),Je=new ne({}),Qe=new ne({}),{c(){I=l("meta"),ro=c(),P=l("h1"),O=l("a"),yt=l("span"),_(se.$$.fragment),Tl=c(),bt=l("span"),Rl=s("Godot RL Agents"),io=c(),L=l("p"),re=l("a"),Sl=s("Godot RL Agents"),ql=s(" is an Open Source package that allows video game creators, AI researchers and hobbyists the opportunity "),Et=l("strong"),Cl=s("to learn complex behaviors for their Non Player Characters or agents"),Dl=s("."),ho=c(),Xe=l("p"),Nl=s("The library provides:"),po=c(),f=l("ul"),ie=l("li"),Ml=s("An interface between games created in the\xA0"),he=l("a"),Ol=s("Godot Engine"),Wl=s("\xA0and Machine Learning algorithms running in Python"),zl=c(),m=l("li"),Bl=s("Wrappers for four well known rl frameworks: "),pe=l("a"),Hl=s("StableBaselines3"),Fl=s(", "),ce=l("a"),Yl=s("CleanRL"),Ul=s(", "),de=l("a"),Jl=s("Sample Factory"),Kl=s(" and\xA0"),fe=l("a"),Ql=s("Ray RLLib"),Zl=c(),At=l("li"),Vl=s("Support for memory-based agents with LSTM or attention based interfaces"),Xl=c(),et=l("li"),ea=s("Support for "),kt=l("em"),ta=s("2D and 3D games"),oa=c(),ue=l("li"),la=s("A suite of "),Gt=l("em"),aa=s("AI sensors"),na=s(" to augment your agent\u2019s capacity to observe the game world"),sa=c(),me=l("li"),ra=s("Godot and Godot RL Agents are "),$t=l("strong"),ia=s("completely free and open source under a very permissive MIT license"),ha=s(". No strings attached, no royalties, nothing."),co=c(),g=l("p"),pa=s("You can find out more about Godot RL agents on their "),ge=l("a"),ca=s("GitHub page"),da=s(" or their AAAI-2022 Workshop\xA0"),ve=l("a"),fa=s("paper"),ua=s(". The library\u2019s creator, "),_e=l("a"),ma=s("Ed Beeching"),ga=s(", is a Research Scientist here at Hugging Face."),fo=c(),we=l("p"),va=s("Installation of the library is simple: "),xt=l("code"),_a=s("pip install godot-rl"),uo=c(),T=l("h2"),W=l("a"),jt=l("span"),_(ye.$$.fragment),wa=c(),It=l("span"),ya=s("Create a custom RL environment with Godot RL Agents"),mo=c(),z=l("p"),ba=s("In this section, you will "),Pt=l("strong"),Ea=s("learn how to create a custom environment in the Godot Game Engine"),Aa=s(" and then implement an AI controller that learns to play with Deep Reinforcement Learning."),go=c(),B=l("p"),ka=s("The example game we create today is simple, "),Lt=l("strong"),Ga=s("but shows off many of the features of the Godot Engine and the Godot RL Agents library"),$a=s(".You can then dive into the examples for more complex environments and behaviors."),vo=c(),H=l("p"),xa=s("The environment we will be building today is called Ring Pong, the game of pong but the pitch is a ring and the paddle moves around the ring. The "),Tt=l("strong"),ja=s("objective is to keep the ball bouncing inside the ring"),Ia=s("."),_o=c(),be=l("img"),wo=c(),R=l("h3"),F=l("a"),Rt=l("span"),_(Ee.$$.fragment),Pa=c(),St=l("span"),La=s("Installing the Godot Game Engine"),yo=c(),k=l("p"),Ta=s("The "),Ae=l("a"),Ra=s("Godot game engine"),Sa=s(" is an open source tool for the "),qt=l("strong"),qa=s("creation of video games, tools and user interfaces"),Ca=s("."),bo=c(),Y=l("p"),Da=s("Godot Engine is a feature-packed, cross-platform game engine designed to create 2D and 3D games from a unified interface. It provides a comprehensive set of common tools, so users "),Ct=l("strong"),Na=s("can focus on making games without having to reinvent the wheel"),Ma=s(". Games can be exported in one click to a number of platforms, including the major desktop platforms (Linux, macOS, Windows) as well as mobile (Android, iOS) and web-based (HTML5) platforms."),Eo=c(),u=l("p"),Oa=s("While we will guide you through the steps to implement your agent, you may wish to learn more about the Godot Game Engine. Their "),ke=l("a"),Wa=s("documentation"),za=s(" is thorough, there are many tutorials on YouTube we would also recommend "),Ge=l("a"),Ba=s("GDQuest"),Ha=s(", "),$e=l("a"),Fa=s("KidsCanCode"),Ya=s(" and "),xe=l("a"),Ua=s("Bramwell"),Ja=s(" as sources of information."),Ao=c(),U=l("p"),Ka=s("In order to create games in Godot, "),Dt=l("strong"),Qa=s("you must first download the editor"),Za=s(". Godot RL Agents supports the latest version of Godot, Godot 4.0."),ko=c(),tt=l("p"),Va=s("Which can be downloaded at the following links:"),Go=c(),G=l("ul"),Nt=l("li"),je=l("a"),Xa=s("Windows"),en=c(),Mt=l("li"),Ie=l("a"),tn=s("Mac"),on=c(),Ot=l("li"),Pe=l("a"),ln=s("Linux"),$o=c(),S=l("h3"),J=l("a"),Wt=l("span"),_(Le.$$.fragment),an=c(),zt=l("span"),nn=s("Loading the starter project"),xo=c(),ot=l("p"),sn=s("We provide two versions of the codebase:"),jo=c(),K=l("ul"),Bt=l("li"),Te=l("a"),rn=s("A starter project, to download and follow along for this tutorial"),hn=c(),Ht=l("li"),Re=l("a"),pn=s("A final version of the project, for comparison and debugging."),Io=c(),$=l("p"),cn=s("To load the project, in the Godot Project Manager click "),Ft=l("strong"),dn=s("Import"),fn=s(", navigate to where the files are located and load the "),Yt=l("strong"),un=s("project.godot"),mn=s(" file."),Po=c(),lt=l("p"),gn=s("If you press F5 or play in the editor, you should be able to play the game in human mode. There are several instances of the game running, this is because we want to speed up training our AI agent with many parallel environments."),Lo=c(),q=l("h3"),Q=l("a"),Ut=l("span"),_(Se.$$.fragment),vn=c(),Jt=l("span"),_n=s("Installing the Godot RL Agents plugin"),To=c(),at=l("p"),wn=s("The Godot RL Agents plugin can be installed from the Github repo or with the Godot Asset Lib in the editor."),Ro=c(),nt=l("p"),yn=s("First click on the AssetLib and search for \u201Crl\u201D"),So=c(),qe=l("img"),qo=c(),Z=l("p"),bn=s("Then click on Godot RL Agents, click Download and unselect the LICIENSE and "),Ce=l("a"),En=s("README.md"),An=s(" files. Then click install."),Co=c(),De=l("img"),Do=c(),st=l("p"),kn=s("The Godot RL Agents plugin is now downloaded to your machine your machine. Now click on Project \u2192 Project settings and enable the addon:"),No=c(),Ne=l("img"),Mo=c(),C=l("h3"),V=l("a"),Kt=l("span"),_(Me.$$.fragment),Gn=c(),Qt=l("span"),$n=s("Adding the AI controller"),Oo=c(),rt=l("p"),xn=s("We now want to add an AI controller to our game. Open the player.tscn scene, on the left you should see a hierarchy of nodes that looks like this:"),Wo=c(),Oe=l("img"),zo=c(),x=l("p"),jn=s("Right click the "),Zt=l("strong"),In=s("Player"),Pn=s(" node and click "),Vt=l("strong"),Ln=s("Add Child Node."),Tn=s(" There are many nodes listed here, search for AIController3D and create it."),Bo=c(),We=l("img"),Ho=c(),it=l("p"),Rn=s("The AI Controller Node should have been added to the scene tree, next to it is a scroll. Click on it to open the script that is attached to the AIController. The Godot game engine uses a scripting language called GDScript, which is syntactically similar to python. The script contains methods that need to be implemented in order to get our AI controller working."),Fo=c(),_(ze.$$.fragment),Yo=c(),ht=l("p"),Sn=s("In order to implement these methods, we will need to create a class that inherits from AIController3D. This is easy to do in Godot, and is called \u201Cextending\u201D a class."),Uo=c(),X=l("p"),qn=s("Right click the AIController3D Node and click \u201CExtend Script\u201D and call the new script "),Xt=l("code"),Cn=s("controller.gd"),Dn=s(". You should now have an almost empty script file that looks like this:"),Jo=c(),_(Be.$$.fragment),Ko=c(),pt=l("p"),Nn=s("We will now implement the 4 missing methods, delete this code and replace it with the following:"),Qo=c(),_(He.$$.fragment),Zo=c(),ct=l("p"),Mn=s("We have now defined the agent\u2019s observation, which is the position and velocity of the ball in its local cooridinate space. We have also defined the action space of the agent, which is a single contuninous value ranging from -1 to +1."),Vo=c(),ee=l("p"),On=s("The next step is to update the Player\u2019s script to use the actions from the AIController, edit the Player\u2019s script by clicking on the scroll next to the player node, update the code in "),eo=l("code"),Wn=s("Player.gd"),zn=s(" to the following the following:"),Xo=c(),_(Fe.$$.fragment),el=c(),dt=l("p"),Bn=s("We now need to synchronize between the game running in Godot and the neural network being trained in Python. Godot RL agents provides a node that does just that. Open the train.tscn scene, right click on the root node and click \u201CAdd child node\u201D. Then, search for \u201Csync\u201D and add a Godot RL Agents Sync node. This node handles the communication between Python and Godot over TCP."),tl=c(),Ye=l("p"),Hn=s("You can run training live in the the editor, by first launching the python training with "),to=l("code"),Fn=s("gdrl"),ol=c(),ft=l("p"),Yn=s("In this simple example, a reasonable policy is learned in several minutes. You may wish to speed up training, click on the Sync node in the train scene and you will see there is a \u201CSpeed Up\u201D property exposed in the editor:"),ll=c(),Ue=l("img"),al=c(),ut=l("p"),Un=s("Try setting this property up to 8 to speed up training. This can be a great benefit on more complex environments, like the multi-player FPS we will learn about in the next chapter."),nl=c(),D=l("h3"),te=l("a"),oo=l("span"),_(Je.$$.fragment),Jn=c(),lo=l("span"),Kn=s("There\u2019s more!"),sl=c(),oe=l("p"),Qn=s("We have only scratched the surface of what can be achieved with Godot RL Agents, the library includes custom sensors and cameras to enrich the information available to the agent. Take a look at the "),Ke=l("a"),Zn=s("examples"),Vn=s(" to find out more!"),rl=c(),N=l("h2"),le=l("a"),ao=l("span"),_(Qe.$$.fragment),Xn=c(),no=l("span"),es=s("Author"),il=c(),Ze=l("p"),ts=s("This section was written by "),mt=l("a"),os=s("Edward Beeching"),this.h()},l(e){const i=Kr('[data-svelte="svelte-1phssyn"]',document.head);I=a(i,"META",{name:!0,content:!0}),i.forEach(t),ro=d(e),P=a(e,"H1",{class:!0});var pl=n(P);O=a(pl,"A",{id:!0,class:!0,href:!0});var ms=n(O);yt=a(ms,"SPAN",{});var gs=n(yt);w(se.$$.fragment,gs),gs.forEach(t),ms.forEach(t),Tl=d(pl),bt=a(pl,"SPAN",{});var vs=n(bt);Rl=r(vs,"Godot RL Agents"),vs.forEach(t),pl.forEach(t),io=d(e),L=a(e,"P",{});var so=n(L);re=a(so,"A",{href:!0,rel:!0});var _s=n(re);Sl=r(_s,"Godot RL Agents"),_s.forEach(t),ql=r(so," is an Open Source package that allows video game creators, AI researchers and hobbyists the opportunity "),Et=a(so,"STRONG",{});var ws=n(Et);Cl=r(ws,"to learn complex behaviors for their Non Player Characters or agents"),ws.forEach(t),Dl=r(so,"."),so.forEach(t),ho=d(e),Xe=a(e,"P",{});var ys=n(Xe);Nl=r(ys,"The library provides:"),ys.forEach(t),po=d(e),f=a(e,"UL",{});var v=n(f);ie=a(v,"LI",{});var cl=n(ie);Ml=r(cl,"An interface between games created in the\xA0"),he=a(cl,"A",{href:!0,rel:!0});var bs=n(he);Ol=r(bs,"Godot Engine"),bs.forEach(t),Wl=r(cl,"\xA0and Machine Learning algorithms running in Python"),cl.forEach(t),zl=d(v),m=a(v,"LI",{});var M=n(m);Bl=r(M,"Wrappers for four well known rl frameworks: "),pe=a(M,"A",{href:!0,rel:!0});var Es=n(pe);Hl=r(Es,"StableBaselines3"),Es.forEach(t),Fl=r(M,", "),ce=a(M,"A",{href:!0,rel:!0});var As=n(ce);Yl=r(As,"CleanRL"),As.forEach(t),Ul=r(M,", "),de=a(M,"A",{href:!0,rel:!0});var ks=n(de);Jl=r(ks,"Sample Factory"),ks.forEach(t),Kl=r(M," and\xA0"),fe=a(M,"A",{href:!0,rel:!0});var Gs=n(fe);Ql=r(Gs,"Ray RLLib"),Gs.forEach(t),M.forEach(t),Zl=d(v),At=a(v,"LI",{});var $s=n(At);Vl=r($s,"Support for memory-based agents with LSTM or attention based interfaces"),$s.forEach(t),Xl=d(v),et=a(v,"LI",{});var ls=n(et);ea=r(ls,"Support for "),kt=a(ls,"EM",{});var xs=n(kt);ta=r(xs,"2D and 3D games"),xs.forEach(t),ls.forEach(t),oa=d(v),ue=a(v,"LI",{});var dl=n(ue);la=r(dl,"A suite of "),Gt=a(dl,"EM",{});var js=n(Gt);aa=r(js,"AI sensors"),js.forEach(t),na=r(dl," to augment your agent\u2019s capacity to observe the game world"),dl.forEach(t),sa=d(v),me=a(v,"LI",{});var fl=n(me);ra=r(fl,"Godot and Godot RL Agents are "),$t=a(fl,"STRONG",{});var Is=n($t);ia=r(Is,"completely free and open source under a very permissive MIT license"),Is.forEach(t),ha=r(fl,". No strings attached, no royalties, nothing."),fl.forEach(t),v.forEach(t),co=d(e),g=a(e,"P",{});var ae=n(g);pa=r(ae,"You can find out more about Godot RL agents on their "),ge=a(ae,"A",{href:!0,rel:!0});var Ps=n(ge);ca=r(Ps,"GitHub page"),Ps.forEach(t),da=r(ae," or their AAAI-2022 Workshop\xA0"),ve=a(ae,"A",{href:!0,rel:!0});var Ls=n(ve);fa=r(Ls,"paper"),Ls.forEach(t),ua=r(ae,". The library\u2019s creator, "),_e=a(ae,"A",{href:!0,rel:!0});var Ts=n(_e);ma=r(Ts,"Ed Beeching"),Ts.forEach(t),ga=r(ae,", is a Research Scientist here at Hugging Face."),ae.forEach(t),fo=d(e),we=a(e,"P",{});var as=n(we);va=r(as,"Installation of the library is simple: "),xt=a(as,"CODE",{});var Rs=n(xt);_a=r(Rs,"pip install godot-rl"),Rs.forEach(t),as.forEach(t),uo=d(e),T=a(e,"H2",{class:!0});var ul=n(T);W=a(ul,"A",{id:!0,class:!0,href:!0});var Ss=n(W);jt=a(Ss,"SPAN",{});var qs=n(jt);w(ye.$$.fragment,qs),qs.forEach(t),Ss.forEach(t),wa=d(ul),It=a(ul,"SPAN",{});var Cs=n(It);ya=r(Cs,"Create a custom RL environment with Godot RL Agents"),Cs.forEach(t),ul.forEach(t),mo=d(e),z=a(e,"P",{});var ml=n(z);ba=r(ml,"In this section, you will "),Pt=a(ml,"STRONG",{});var Ds=n(Pt);Ea=r(Ds,"learn how to create a custom environment in the Godot Game Engine"),Ds.forEach(t),Aa=r(ml," and then implement an AI controller that learns to play with Deep Reinforcement Learning."),ml.forEach(t),go=d(e),B=a(e,"P",{});var gl=n(B);ka=r(gl,"The example game we create today is simple, "),Lt=a(gl,"STRONG",{});var Ns=n(Lt);Ga=r(Ns,"but shows off many of the features of the Godot Engine and the Godot RL Agents library"),Ns.forEach(t),$a=r(gl,".You can then dive into the examples for more complex environments and behaviors."),gl.forEach(t),vo=d(e),H=a(e,"P",{});var vl=n(H);xa=r(vl,"The environment we will be building today is called Ring Pong, the game of pong but the pitch is a ring and the paddle moves around the ring. The "),Tt=a(vl,"STRONG",{});var Ms=n(Tt);ja=r(Ms,"objective is to keep the ball bouncing inside the ring"),Ms.forEach(t),Ia=r(vl,"."),vl.forEach(t),_o=d(e),be=a(e,"IMG",{src:!0,alt:!0}),wo=d(e),R=a(e,"H3",{class:!0});var _l=n(R);F=a(_l,"A",{id:!0,class:!0,href:!0});var Os=n(F);Rt=a(Os,"SPAN",{});var Ws=n(Rt);w(Ee.$$.fragment,Ws),Ws.forEach(t),Os.forEach(t),Pa=d(_l),St=a(_l,"SPAN",{});var zs=n(St);La=r(zs,"Installing the Godot Game Engine"),zs.forEach(t),_l.forEach(t),yo=d(e),k=a(e,"P",{});var gt=n(k);Ta=r(gt,"The "),Ae=a(gt,"A",{href:!0,rel:!0});var Bs=n(Ae);Ra=r(Bs,"Godot game engine"),Bs.forEach(t),Sa=r(gt," is an open source tool for the "),qt=a(gt,"STRONG",{});var Hs=n(qt);qa=r(Hs,"creation of video games, tools and user interfaces"),Hs.forEach(t),Ca=r(gt,"."),gt.forEach(t),bo=d(e),Y=a(e,"P",{});var wl=n(Y);Da=r(wl,"Godot Engine is a feature-packed, cross-platform game engine designed to create 2D and 3D games from a unified interface. It provides a comprehensive set of common tools, so users "),Ct=a(wl,"STRONG",{});var Fs=n(Ct);Na=r(Fs,"can focus on making games without having to reinvent the wheel"),Fs.forEach(t),Ma=r(wl,". Games can be exported in one click to a number of platforms, including the major desktop platforms (Linux, macOS, Windows) as well as mobile (Android, iOS) and web-based (HTML5) platforms."),wl.forEach(t),Eo=d(e),u=a(e,"P",{});var j=n(u);Oa=r(j,"While we will guide you through the steps to implement your agent, you may wish to learn more about the Godot Game Engine. Their "),ke=a(j,"A",{href:!0,rel:!0});var Ys=n(ke);Wa=r(Ys,"documentation"),Ys.forEach(t),za=r(j," is thorough, there are many tutorials on YouTube we would also recommend "),Ge=a(j,"A",{href:!0,rel:!0});var Us=n(Ge);Ba=r(Us,"GDQuest"),Us.forEach(t),Ha=r(j,", "),$e=a(j,"A",{href:!0,rel:!0});var Js=n($e);Fa=r(Js,"KidsCanCode"),Js.forEach(t),Ya=r(j," and "),xe=a(j,"A",{href:!0,rel:!0});var Ks=n(xe);Ua=r(Ks,"Bramwell"),Ks.forEach(t),Ja=r(j," as sources of information."),j.forEach(t),Ao=d(e),U=a(e,"P",{});var yl=n(U);Ka=r(yl,"In order to create games in Godot, "),Dt=a(yl,"STRONG",{});var Qs=n(Dt);Qa=r(Qs,"you must first download the editor"),Qs.forEach(t),Za=r(yl,". Godot RL Agents supports the latest version of Godot, Godot 4.0."),yl.forEach(t),ko=d(e),tt=a(e,"P",{});var Zs=n(tt);Va=r(Zs,"Which can be downloaded at the following links:"),Zs.forEach(t),Go=d(e),G=a(e,"UL",{});var vt=n(G);Nt=a(vt,"LI",{});var Vs=n(Nt);je=a(Vs,"A",{href:!0,rel:!0});var Xs=n(je);Xa=r(Xs,"Windows"),Xs.forEach(t),Vs.forEach(t),en=d(vt),Mt=a(vt,"LI",{});var er=n(Mt);Ie=a(er,"A",{href:!0,rel:!0});var tr=n(Ie);tn=r(tr,"Mac"),tr.forEach(t),er.forEach(t),on=d(vt),Ot=a(vt,"LI",{});var or=n(Ot);Pe=a(or,"A",{href:!0,rel:!0});var lr=n(Pe);ln=r(lr,"Linux"),lr.forEach(t),or.forEach(t),vt.forEach(t),$o=d(e),S=a(e,"H3",{class:!0});var bl=n(S);J=a(bl,"A",{id:!0,class:!0,href:!0});var ar=n(J);Wt=a(ar,"SPAN",{});var nr=n(Wt);w(Le.$$.fragment,nr),nr.forEach(t),ar.forEach(t),an=d(bl),zt=a(bl,"SPAN",{});var sr=n(zt);nn=r(sr,"Loading the starter project"),sr.forEach(t),bl.forEach(t),xo=d(e),ot=a(e,"P",{});var rr=n(ot);sn=r(rr,"We provide two versions of the codebase:"),rr.forEach(t),jo=d(e),K=a(e,"UL",{});var El=n(K);Bt=a(El,"LI",{});var ir=n(Bt);Te=a(ir,"A",{href:!0,rel:!0});var hr=n(Te);rn=r(hr,"A starter project, to download and follow along for this tutorial"),hr.forEach(t),ir.forEach(t),hn=d(El),Ht=a(El,"LI",{});var pr=n(Ht);Re=a(pr,"A",{href:!0,rel:!0});var cr=n(Re);pn=r(cr,"A final version of the project, for comparison and debugging."),cr.forEach(t),pr.forEach(t),El.forEach(t),Io=d(e),$=a(e,"P",{});var _t=n($);cn=r(_t,"To load the project, in the Godot Project Manager click "),Ft=a(_t,"STRONG",{});var dr=n(Ft);dn=r(dr,"Import"),dr.forEach(t),fn=r(_t,", navigate to where the files are located and load the "),Yt=a(_t,"STRONG",{});var fr=n(Yt);un=r(fr,"project.godot"),fr.forEach(t),mn=r(_t," file."),_t.forEach(t),Po=d(e),lt=a(e,"P",{});var ur=n(lt);gn=r(ur,"If you press F5 or play in the editor, you should be able to play the game in human mode. There are several instances of the game running, this is because we want to speed up training our AI agent with many parallel environments."),ur.forEach(t),Lo=d(e),q=a(e,"H3",{class:!0});var Al=n(q);Q=a(Al,"A",{id:!0,class:!0,href:!0});var mr=n(Q);Ut=a(mr,"SPAN",{});var gr=n(Ut);w(Se.$$.fragment,gr),gr.forEach(t),mr.forEach(t),vn=d(Al),Jt=a(Al,"SPAN",{});var vr=n(Jt);_n=r(vr,"Installing the Godot RL Agents plugin"),vr.forEach(t),Al.forEach(t),To=d(e),at=a(e,"P",{});var _r=n(at);wn=r(_r,"The Godot RL Agents plugin can be installed from the Github repo or with the Godot Asset Lib in the editor."),_r.forEach(t),Ro=d(e),nt=a(e,"P",{});var wr=n(nt);yn=r(wr,"First click on the AssetLib and search for \u201Crl\u201D"),wr.forEach(t),So=d(e),qe=a(e,"IMG",{src:!0,alt:!0}),qo=d(e),Z=a(e,"P",{});var kl=n(Z);bn=r(kl,"Then click on Godot RL Agents, click Download and unselect the LICIENSE and "),Ce=a(kl,"A",{href:!0,rel:!0});var yr=n(Ce);En=r(yr,"README.md"),yr.forEach(t),An=r(kl," files. Then click install."),kl.forEach(t),Co=d(e),De=a(e,"IMG",{src:!0,alt:!0}),Do=d(e),st=a(e,"P",{});var br=n(st);kn=r(br,"The Godot RL Agents plugin is now downloaded to your machine your machine. Now click on Project \u2192 Project settings and enable the addon:"),br.forEach(t),No=d(e),Ne=a(e,"IMG",{src:!0,alt:!0}),Mo=d(e),C=a(e,"H3",{class:!0});var Gl=n(C);V=a(Gl,"A",{id:!0,class:!0,href:!0});var Er=n(V);Kt=a(Er,"SPAN",{});var Ar=n(Kt);w(Me.$$.fragment,Ar),Ar.forEach(t),Er.forEach(t),Gn=d(Gl),Qt=a(Gl,"SPAN",{});var kr=n(Qt);$n=r(kr,"Adding the AI controller"),kr.forEach(t),Gl.forEach(t),Oo=d(e),rt=a(e,"P",{});var Gr=n(rt);xn=r(Gr,"We now want to add an AI controller to our game. Open the player.tscn scene, on the left you should see a hierarchy of nodes that looks like this:"),Gr.forEach(t),Wo=d(e),Oe=a(e,"IMG",{src:!0,alt:!0}),zo=d(e),x=a(e,"P",{});var wt=n(x);jn=r(wt,"Right click the "),Zt=a(wt,"STRONG",{});var $r=n(Zt);In=r($r,"Player"),$r.forEach(t),Pn=r(wt," node and click "),Vt=a(wt,"STRONG",{});var xr=n(Vt);Ln=r(xr,"Add Child Node."),xr.forEach(t),Tn=r(wt," There are many nodes listed here, search for AIController3D and create it."),wt.forEach(t),Bo=d(e),We=a(e,"IMG",{src:!0,alt:!0}),Ho=d(e),it=a(e,"P",{});var jr=n(it);Rn=r(jr,"The AI Controller Node should have been added to the scene tree, next to it is a scroll. Click on it to open the script that is attached to the AIController. The Godot game engine uses a scripting language called GDScript, which is syntactically similar to python. The script contains methods that need to be implemented in order to get our AI controller working."),jr.forEach(t),Fo=d(e),w(ze.$$.fragment,e),Yo=d(e),ht=a(e,"P",{});var Ir=n(ht);Sn=r(Ir,"In order to implement these methods, we will need to create a class that inherits from AIController3D. This is easy to do in Godot, and is called \u201Cextending\u201D a class."),Ir.forEach(t),Uo=d(e),X=a(e,"P",{});var $l=n(X);qn=r($l,"Right click the AIController3D Node and click \u201CExtend Script\u201D and call the new script "),Xt=a($l,"CODE",{});var Pr=n(Xt);Cn=r(Pr,"controller.gd"),Pr.forEach(t),Dn=r($l,". You should now have an almost empty script file that looks like this:"),$l.forEach(t),Jo=d(e),w(Be.$$.fragment,e),Ko=d(e),pt=a(e,"P",{});var Lr=n(pt);Nn=r(Lr,"We will now implement the 4 missing methods, delete this code and replace it with the following:"),Lr.forEach(t),Qo=d(e),w(He.$$.fragment,e),Zo=d(e),ct=a(e,"P",{});var Tr=n(ct);Mn=r(Tr,"We have now defined the agent\u2019s observation, which is the position and velocity of the ball in its local cooridinate space. We have also defined the action space of the agent, which is a single contuninous value ranging from -1 to +1."),Tr.forEach(t),Vo=d(e),ee=a(e,"P",{});var xl=n(ee);On=r(xl,"The next step is to update the Player\u2019s script to use the actions from the AIController, edit the Player\u2019s script by clicking on the scroll next to the player node, update the code in "),eo=a(xl,"CODE",{});var Rr=n(eo);Wn=r(Rr,"Player.gd"),Rr.forEach(t),zn=r(xl," to the following the following:"),xl.forEach(t),Xo=d(e),w(Fe.$$.fragment,e),el=d(e),dt=a(e,"P",{});var Sr=n(dt);Bn=r(Sr,"We now need to synchronize between the game running in Godot and the neural network being trained in Python. Godot RL agents provides a node that does just that. Open the train.tscn scene, right click on the root node and click \u201CAdd child node\u201D. Then, search for \u201Csync\u201D and add a Godot RL Agents Sync node. This node handles the communication between Python and Godot over TCP."),Sr.forEach(t),tl=d(e),Ye=a(e,"P",{});var ns=n(Ye);Hn=r(ns,"You can run training live in the the editor, by first launching the python training with "),to=a(ns,"CODE",{});var qr=n(to);Fn=r(qr,"gdrl"),qr.forEach(t),ns.forEach(t),ol=d(e),ft=a(e,"P",{});var Cr=n(ft);Yn=r(Cr,"In this simple example, a reasonable policy is learned in several minutes. You may wish to speed up training, click on the Sync node in the train scene and you will see there is a \u201CSpeed Up\u201D property exposed in the editor:"),Cr.forEach(t),ll=d(e),Ue=a(e,"IMG",{src:!0,alt:!0}),al=d(e),ut=a(e,"P",{});var Dr=n(ut);Un=r(Dr,"Try setting this property up to 8 to speed up training. This can be a great benefit on more complex environments, like the multi-player FPS we will learn about in the next chapter."),Dr.forEach(t),nl=d(e),D=a(e,"H3",{class:!0});var jl=n(D);te=a(jl,"A",{id:!0,class:!0,href:!0});var Nr=n(te);oo=a(Nr,"SPAN",{});var Mr=n(oo);w(Je.$$.fragment,Mr),Mr.forEach(t),Nr.forEach(t),Jn=d(jl),lo=a(jl,"SPAN",{});var Or=n(lo);Kn=r(Or,"There\u2019s more!"),Or.forEach(t),jl.forEach(t),sl=d(e),oe=a(e,"P",{});var Il=n(oe);Qn=r(Il,"We have only scratched the surface of what can be achieved with Godot RL Agents, the library includes custom sensors and cameras to enrich the information available to the agent. Take a look at the "),Ke=a(Il,"A",{href:!0,rel:!0});var Wr=n(Ke);Zn=r(Wr,"examples"),Wr.forEach(t),Vn=r(Il," to find out more!"),Il.forEach(t),rl=d(e),N=a(e,"H2",{class:!0});var Pl=n(N);le=a(Pl,"A",{id:!0,class:!0,href:!0});var zr=n(le);ao=a(zr,"SPAN",{});var Br=n(ao);w(Qe.$$.fragment,Br),Br.forEach(t),zr.forEach(t),Xn=d(Pl),no=a(Pl,"SPAN",{});var Hr=n(no);es=r(Hr,"Author"),Hr.forEach(t),Pl.forEach(t),il=d(e),Ze=a(e,"P",{});var ss=n(Ze);ts=r(ss,"This section was written by "),mt=a(ss,"A",{href:!0});var Fr=n(mt);os=r(Fr,"Edward Beeching"),Fr.forEach(t),ss.forEach(t),this.h()},h(){p(I,"name","hf:doc:metadata"),p(I,"content",JSON.stringify(Xr)),p(O,"id","godot-rl-agents"),p(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(O,"href","#godot-rl-agents"),p(P,"class","relative group"),p(re,"href","https://github.com/edbeeching/godot_rl_agents"),p(re,"rel","nofollow"),p(he,"href","https://godotengine.org/"),p(he,"rel","nofollow"),p(pe,"href","https://stable-baselines3.readthedocs.io/en/master/"),p(pe,"rel","nofollow"),p(ce,"href","https://docs.cleanrl.dev/"),p(ce,"rel","nofollow"),p(de,"href","https://www.samplefactory.dev/"),p(de,"rel","nofollow"),p(fe,"href","https://docs.ray.io/en/latest/rllib-algorithms.html"),p(fe,"rel","nofollow"),p(ge,"href","https://github.com/edbeeching/godot_rl_agents"),p(ge,"rel","nofollow"),p(ve,"href","https://arxiv.org/abs/2112.03636"),p(ve,"rel","nofollow"),p(_e,"href","https://edbeeching.github.io/"),p(_e,"rel","nofollow"),p(W,"id","create-a-custom-rl-environment-with-godot-rl-agents"),p(W,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(W,"href","#create-a-custom-rl-environment-with-godot-rl-agents"),p(T,"class","relative group"),Ve(be.src,is="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ringpong.gif")||p(be,"src",is),p(be,"alt","Ring Pong"),p(F,"id","installing-the-godot-game-engine"),p(F,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(F,"href","#installing-the-godot-game-engine"),p(R,"class","relative group"),p(Ae,"href","https://godotengine.org/"),p(Ae,"rel","nofollow"),p(ke,"href","https://docs.godotengine.org/en/latest/index.html"),p(ke,"rel","nofollow"),p(Ge,"href","https://www.gdquest.com/"),p(Ge,"rel","nofollow"),p($e,"href","https://kidscancode.org/godot_recipes/4.x/"),p($e,"rel","nofollow"),p(xe,"href","https://www.youtube.com/channel/UCczi7Aq_dTKrQPF5ZV5J3gg"),p(xe,"rel","nofollow"),p(je,"href","https://downloads.tuxfamily.org/godotengine/4.0.1/Godot_v4.0.1-stable_win64.exe.zip"),p(je,"rel","nofollow"),p(Ie,"href","https://downloads.tuxfamily.org/godotengine/4.0.1/Godot_v4.0.1-stable_macos.universal.zip"),p(Ie,"rel","nofollow"),p(Pe,"href","https://downloads.tuxfamily.org/godotengine/4.0.1/Godot_v4.0.1-stable_linux.x86_64.zip"),p(Pe,"rel","nofollow"),p(J,"id","loading-the-starter-project"),p(J,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(J,"href","#loading-the-starter-project"),p(S,"class","relative group"),p(Te,"href","https://drive.google.com/file/d/1C7xd3TibJHlxFEJPBgBLpksgxrFZ3D8e/view?usp=share_link"),p(Te,"rel","nofollow"),p(Re,"href","https://drive.google.com/file/d/1k-b2Bu7uIA6poApbouX4c3sq98xqogpZ/view?usp=share_link"),p(Re,"rel","nofollow"),p(Q,"id","installing-the-godot-rl-agents-plugin"),p(Q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(Q,"href","#installing-the-godot-rl-agents-plugin"),p(q,"class","relative group"),Ve(qe.src,hs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/godot1.png")||p(qe,"src",hs),p(qe,"alt","Godot"),p(Ce,"href","http://README.md"),p(Ce,"rel","nofollow"),Ve(De.src,ps="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/godot2.png")||p(De,"src",ps),p(De,"alt","Godot"),Ve(Ne.src,cs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/godot3.png")||p(Ne,"src",cs),p(Ne,"alt","Godot"),p(V,"id","adding-the-ai-controller"),p(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(V,"href","#adding-the-ai-controller"),p(C,"class","relative group"),Ve(Oe.src,ds="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/godot4.png")||p(Oe,"src",ds),p(Oe,"alt","Godot"),Ve(We.src,fs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/godot5.png")||p(We,"src",fs),p(We,"alt","Godot"),Ve(Ue.src,us="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/godot6.png")||p(Ue,"src",us),p(Ue,"alt","Godot"),p(te,"id","theres-more"),p(te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(te,"href","#theres-more"),p(D,"class","relative group"),p(Ke,"href","https://github.com/edbeeching/godot_rl_agents_examples"),p(Ke,"rel","nofollow"),p(le,"id","author"),p(le,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(le,"href","#author"),p(N,"class","relative group"),p(mt,"href","https://twitter.com/edwardbeeching")},m(e,i){o(document.head,I),h(e,ro,i),h(e,P,i),o(P,O),o(O,yt),y(se,yt,null),o(P,Tl),o(P,bt),o(bt,Rl),h(e,io,i),h(e,L,i),o(L,re),o(re,Sl),o(L,ql),o(L,Et),o(Et,Cl),o(L,Dl),h(e,ho,i),h(e,Xe,i),o(Xe,Nl),h(e,po,i),h(e,f,i),o(f,ie),o(ie,Ml),o(ie,he),o(he,Ol),o(ie,Wl),o(f,zl),o(f,m),o(m,Bl),o(m,pe),o(pe,Hl),o(m,Fl),o(m,ce),o(ce,Yl),o(m,Ul),o(m,de),o(de,Jl),o(m,Kl),o(m,fe),o(fe,Ql),o(f,Zl),o(f,At),o(At,Vl),o(f,Xl),o(f,et),o(et,ea),o(et,kt),o(kt,ta),o(f,oa),o(f,ue),o(ue,la),o(ue,Gt),o(Gt,aa),o(ue,na),o(f,sa),o(f,me),o(me,ra),o(me,$t),o($t,ia),o(me,ha),h(e,co,i),h(e,g,i),o(g,pa),o(g,ge),o(ge,ca),o(g,da),o(g,ve),o(ve,fa),o(g,ua),o(g,_e),o(_e,ma),o(g,ga),h(e,fo,i),h(e,we,i),o(we,va),o(we,xt),o(xt,_a),h(e,uo,i),h(e,T,i),o(T,W),o(W,jt),y(ye,jt,null),o(T,wa),o(T,It),o(It,ya),h(e,mo,i),h(e,z,i),o(z,ba),o(z,Pt),o(Pt,Ea),o(z,Aa),h(e,go,i),h(e,B,i),o(B,ka),o(B,Lt),o(Lt,Ga),o(B,$a),h(e,vo,i),h(e,H,i),o(H,xa),o(H,Tt),o(Tt,ja),o(H,Ia),h(e,_o,i),h(e,be,i),h(e,wo,i),h(e,R,i),o(R,F),o(F,Rt),y(Ee,Rt,null),o(R,Pa),o(R,St),o(St,La),h(e,yo,i),h(e,k,i),o(k,Ta),o(k,Ae),o(Ae,Ra),o(k,Sa),o(k,qt),o(qt,qa),o(k,Ca),h(e,bo,i),h(e,Y,i),o(Y,Da),o(Y,Ct),o(Ct,Na),o(Y,Ma),h(e,Eo,i),h(e,u,i),o(u,Oa),o(u,ke),o(ke,Wa),o(u,za),o(u,Ge),o(Ge,Ba),o(u,Ha),o(u,$e),o($e,Fa),o(u,Ya),o(u,xe),o(xe,Ua),o(u,Ja),h(e,Ao,i),h(e,U,i),o(U,Ka),o(U,Dt),o(Dt,Qa),o(U,Za),h(e,ko,i),h(e,tt,i),o(tt,Va),h(e,Go,i),h(e,G,i),o(G,Nt),o(Nt,je),o(je,Xa),o(G,en),o(G,Mt),o(Mt,Ie),o(Ie,tn),o(G,on),o(G,Ot),o(Ot,Pe),o(Pe,ln),h(e,$o,i),h(e,S,i),o(S,J),o(J,Wt),y(Le,Wt,null),o(S,an),o(S,zt),o(zt,nn),h(e,xo,i),h(e,ot,i),o(ot,sn),h(e,jo,i),h(e,K,i),o(K,Bt),o(Bt,Te),o(Te,rn),o(K,hn),o(K,Ht),o(Ht,Re),o(Re,pn),h(e,Io,i),h(e,$,i),o($,cn),o($,Ft),o(Ft,dn),o($,fn),o($,Yt),o(Yt,un),o($,mn),h(e,Po,i),h(e,lt,i),o(lt,gn),h(e,Lo,i),h(e,q,i),o(q,Q),o(Q,Ut),y(Se,Ut,null),o(q,vn),o(q,Jt),o(Jt,_n),h(e,To,i),h(e,at,i),o(at,wn),h(e,Ro,i),h(e,nt,i),o(nt,yn),h(e,So,i),h(e,qe,i),h(e,qo,i),h(e,Z,i),o(Z,bn),o(Z,Ce),o(Ce,En),o(Z,An),h(e,Co,i),h(e,De,i),h(e,Do,i),h(e,st,i),o(st,kn),h(e,No,i),h(e,Ne,i),h(e,Mo,i),h(e,C,i),o(C,V),o(V,Kt),y(Me,Kt,null),o(C,Gn),o(C,Qt),o(Qt,$n),h(e,Oo,i),h(e,rt,i),o(rt,xn),h(e,Wo,i),h(e,Oe,i),h(e,zo,i),h(e,x,i),o(x,jn),o(x,Zt),o(Zt,In),o(x,Pn),o(x,Vt),o(Vt,Ln),o(x,Tn),h(e,Bo,i),h(e,We,i),h(e,Ho,i),h(e,it,i),o(it,Rn),h(e,Fo,i),y(ze,e,i),h(e,Yo,i),h(e,ht,i),o(ht,Sn),h(e,Uo,i),h(e,X,i),o(X,qn),o(X,Xt),o(Xt,Cn),o(X,Dn),h(e,Jo,i),y(Be,e,i),h(e,Ko,i),h(e,pt,i),o(pt,Nn),h(e,Qo,i),y(He,e,i),h(e,Zo,i),h(e,ct,i),o(ct,Mn),h(e,Vo,i),h(e,ee,i),o(ee,On),o(ee,eo),o(eo,Wn),o(ee,zn),h(e,Xo,i),y(Fe,e,i),h(e,el,i),h(e,dt,i),o(dt,Bn),h(e,tl,i),h(e,Ye,i),o(Ye,Hn),o(Ye,to),o(to,Fn),h(e,ol,i),h(e,ft,i),o(ft,Yn),h(e,ll,i),h(e,Ue,i),h(e,al,i),h(e,ut,i),o(ut,Un),h(e,nl,i),h(e,D,i),o(D,te),o(te,oo),y(Je,oo,null),o(D,Jn),o(D,lo),o(lo,Kn),h(e,sl,i),h(e,oe,i),o(oe,Qn),o(oe,Ke),o(Ke,Zn),o(oe,Vn),h(e,rl,i),h(e,N,i),o(N,le),o(le,ao),y(Qe,ao,null),o(N,Xn),o(N,no),o(no,es),h(e,il,i),h(e,Ze,i),o(Ze,ts),o(Ze,mt),o(mt,os),hl=!0},p:Qr,i(e){hl||(b(se.$$.fragment,e),b(ye.$$.fragment,e),b(Ee.$$.fragment,e),b(Le.$$.fragment,e),b(Se.$$.fragment,e),b(Me.$$.fragment,e),b(ze.$$.fragment,e),b(Be.$$.fragment,e),b(He.$$.fragment,e),b(Fe.$$.fragment,e),b(Je.$$.fragment,e),b(Qe.$$.fragment,e),hl=!0)},o(e){E(se.$$.fragment,e),E(ye.$$.fragment,e),E(Ee.$$.fragment,e),E(Le.$$.fragment,e),E(Se.$$.fragment,e),E(Me.$$.fragment,e),E(ze.$$.fragment,e),E(Be.$$.fragment,e),E(He.$$.fragment,e),E(Fe.$$.fragment,e),E(Je.$$.fragment,e),E(Qe.$$.fragment,e),hl=!1},d(e){t(I),e&&t(ro),e&&t(P),A(se),e&&t(io),e&&t(L),e&&t(ho),e&&t(Xe),e&&t(po),e&&t(f),e&&t(co),e&&t(g),e&&t(fo),e&&t(we),e&&t(uo),e&&t(T),A(ye),e&&t(mo),e&&t(z),e&&t(go),e&&t(B),e&&t(vo),e&&t(H),e&&t(_o),e&&t(be),e&&t(wo),e&&t(R),A(Ee),e&&t(yo),e&&t(k),e&&t(bo),e&&t(Y),e&&t(Eo),e&&t(u),e&&t(Ao),e&&t(U),e&&t(ko),e&&t(tt),e&&t(Go),e&&t(G),e&&t($o),e&&t(S),A(Le),e&&t(xo),e&&t(ot),e&&t(jo),e&&t(K),e&&t(Io),e&&t($),e&&t(Po),e&&t(lt),e&&t(Lo),e&&t(q),A(Se),e&&t(To),e&&t(at),e&&t(Ro),e&&t(nt),e&&t(So),e&&t(qe),e&&t(qo),e&&t(Z),e&&t(Co),e&&t(De),e&&t(Do),e&&t(st),e&&t(No),e&&t(Ne),e&&t(Mo),e&&t(C),A(Me),e&&t(Oo),e&&t(rt),e&&t(Wo),e&&t(Oe),e&&t(zo),e&&t(x),e&&t(Bo),e&&t(We),e&&t(Ho),e&&t(it),e&&t(Fo),A(ze,e),e&&t(Yo),e&&t(ht),e&&t(Uo),e&&t(X),e&&t(Jo),A(Be,e),e&&t(Ko),e&&t(pt),e&&t(Qo),A(He,e),e&&t(Zo),e&&t(ct),e&&t(Vo),e&&t(ee),e&&t(Xo),A(Fe,e),e&&t(el),e&&t(dt),e&&t(tl),e&&t(Ye),e&&t(ol),e&&t(ft),e&&t(ll),e&&t(Ue),e&&t(al),e&&t(ut),e&&t(nl),e&&t(D),A(Je),e&&t(sl),e&&t(oe),e&&t(rl),e&&t(N),A(Qe),e&&t(il),e&&t(Ze)}}}const Xr={local:"godot-rl-agents",sections:[{local:"create-a-custom-rl-environment-with-godot-rl-agents",sections:[{local:"installing-the-godot-game-engine",title:"Installing the Godot Game Engine"},{local:"loading-the-starter-project",title:"Loading the starter project"},{local:"installing-the-godot-rl-agents-plugin",title:"Installing the Godot RL Agents plugin"},{local:"adding-the-ai-controller",title:"Adding the AI controller"},{local:"theres-more",title:"There\u2019s more!"}],title:"Create a custom RL environment with Godot RL Agents"},{local:"author",title:"Author"}],title:"Godot RL Agents"};function ei(rs){return Zr(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ai extends Yr{constructor(I){super();Ur(this,I,ei,Vr,Jr,{})}}export{ai as default,Xr as metadata};
